#[doc = "Register `GNPTXFSIZ_HOSTMODE` reader"]
pub type R = crate::R<GNPTXFSIZ_HOSTMODE_SPEC>;
#[doc = "Register `GNPTXFSIZ_HOSTMODE` writer"]
pub type W = crate::W<GNPTXFSIZ_HOSTMODE_SPEC>;
#[doc = "Field `NPTxFStAddr` reader - Non-periodic Transmit RAM Start Address"]
pub type NPTX_FST_ADDR_R = crate::FieldReader<u16>;
#[doc = "Field `NPTxFStAddr` writer - Non-periodic Transmit RAM Start Address"]
pub type NPTX_FST_ADDR_W<'a, REG> = crate::FieldWriter<'a, REG, 16, u16>;
#[doc = "Field `NPTxFDep` reader - Non-periodic TxFIFO Depth"]
pub type NPTX_FDEP_R = crate::FieldReader<u16>;
#[doc = "Field `NPTxFDep` writer - Non-periodic TxFIFO Depth"]
pub type NPTX_FDEP_W<'a, REG> = crate::FieldWriter<'a, REG, 16, u16>;
impl R {
    #[doc = "Bits 0:15 - Non-periodic Transmit RAM Start Address"]
    #[inline(always)]
    pub fn nptx_fst_addr(&self) -> NPTX_FST_ADDR_R {
        NPTX_FST_ADDR_R::new((self.bits & 0xffff) as u16)
    }
    #[doc = "Bits 16:31 - Non-periodic TxFIFO Depth"]
    #[inline(always)]
    pub fn nptx_fdep(&self) -> NPTX_FDEP_R {
        NPTX_FDEP_R::new(((self.bits >> 16) & 0xffff) as u16)
    }
}
impl W {
    #[doc = "Bits 0:15 - Non-periodic Transmit RAM Start Address"]
    #[inline(always)]
    #[must_use]
    pub fn nptx_fst_addr(&mut self) -> NPTX_FST_ADDR_W<GNPTXFSIZ_HOSTMODE_SPEC> {
        NPTX_FST_ADDR_W::new(self, 0)
    }
    #[doc = "Bits 16:31 - Non-periodic TxFIFO Depth"]
    #[inline(always)]
    #[must_use]
    pub fn nptx_fdep(&mut self) -> NPTX_FDEP_W<GNPTXFSIZ_HOSTMODE_SPEC> {
        NPTX_FDEP_W::new(self, 16)
    }
    #[doc = r" Writes raw bits to the register."]
    #[doc = r""]
    #[doc = r" # Safety"]
    #[doc = r""]
    #[doc = r" Passing incorrect value can cause undefined behaviour. See reference manual"]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
}
#[doc = "Non-Periodic Transmit FIFO Size Register \\[HOSTMODE\\]\n\nYou can [`read`](crate::generic::Reg::read) this register and get [`gnptxfsiz_hostmode::R`](R).  You can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero) this register using [`gnptxfsiz_hostmode::W`](W). You can also [`modify`](crate::generic::Reg::modify) this register. See [API](https://docs.rs/svd2rust/#read--modify--write-api)."]
pub struct GNPTXFSIZ_HOSTMODE_SPEC;
impl crate::RegisterSpec for GNPTXFSIZ_HOSTMODE_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [`gnptxfsiz_hostmode::R`](R) reader structure"]
impl crate::Readable for GNPTXFSIZ_HOSTMODE_SPEC {}
#[doc = "`write(|w| ..)` method takes [`gnptxfsiz_hostmode::W`](W) writer structure"]
impl crate::Writable for GNPTXFSIZ_HOSTMODE_SPEC {
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets GNPTXFSIZ_HOSTMODE to value 0x0010_011a"]
impl crate::Resettable for GNPTXFSIZ_HOSTMODE_SPEC {
    const RESET_VALUE: Self::Ux = 0x0010_011a;
}
